'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _GridList = require('@material-ui/core/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _GridListTile = require('@material-ui/core/GridListTile');

var _GridListTile2 = _interopRequireDefault(_GridListTile);

var _GridListTileBar = require('@material-ui/core/GridListTileBar');

var _GridListTileBar2 = _interopRequireDefault(_GridListTileBar);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Delete = require('@material-ui/icons/Delete');

var _Delete2 = _interopRequireDefault(_Delete);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fileGridStyles = function fileGridStyles(theme) {
    return {
        container: {
            display: 'flex',
            flexWrap: 'wrap',
            justifyContent: 'space-around',
            overflow: 'hidden',
            background: theme.palette.background.paper
        },
        gridList: {}
    };
};

var FileGrid = function FileGrid(_ref) {
    var classes = _ref.classes,
        files = _ref.files,
        onDeleteClick = _ref.onDeleteClick;
    return _react2.default.createElement(
        'div',
        { className: classes.container },
        _react2.default.createElement(
            _GridList2.default,
            { className: classes.gridList },
            files.map(function (file, index) {
                return _react2.default.createElement(
                    _GridListTile2.default,
                    { key: index },
                    _react2.default.createElement('img', {
                        src: file.preview ? file.preview : file.link,
                        alt: file.name
                    }),
                    _react2.default.createElement(_GridListTileBar2.default, {
                        title: file.name,
                        subtitle: _react2.default.createElement(
                            'span',
                            null,
                            file.length + ' bytes'
                        ),
                        actionIcon: _react2.default.createElement(
                            _IconButton2.default,
                            { onClick: function onClick() {
                                    return onDeleteClick(file, index);
                                } },
                            _react2.default.createElement(_Delete2.default, { color: 'disabled' })
                        )
                    })
                );
            })
        )
    );
};

exports.default = (0, _styles.withStyles)(fileGridStyles)(FileGrid);
module.exports = exports['default'];